/////////////////////////////////////////////////////////////////////////////
// PluginDlg.cpp defines the plugin dialog implementation

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Plugin header files

#include "stdafx.h"
#include "PluginDlg.h"

/////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Initialize plugin dialog (one time)

BOOL CPluginDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

// Register plugin services

	m_GraphicsSrvc = m_Manager->RegisterForGraphicsService();

// Display plugin version information

  CWnd *wnd = GetDlgItem(IDC_VERSION);
  if(wnd != NULL) {
    char buffer[1024];
    sprintf(buffer, "%s\nv%s\n%s", PluginName, PluginVersion, PluginReleaseDate);
    wnd->SetWindowText(buffer);
  }
  UpdateData(FALSE);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Enable/disable service notifications when dialog is displayed/hidden

void CPluginDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
// Being shown

  if(bShow) {

// Switch draw notification on

    m_GraphicsSrvc->SetDrawServiceNotify(m_Handle, this);

  } else {

// Being hidden

// Switch notifications off

    m_GraphicsSrvc->SetDrawServiceNotify(m_Handle, NULL);
  }
}

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Show dialog notification used to hide the plugin dialog during redraw

void CPluginDlg::OnShowDialog(const bool show) 
{

// Move dialog on/off screen during redraw

  CRect rect;
  GetWindowRect(&rect);
  if(show) {
    rect.left-=3000;
    rect.right-=3000;
  } else {
    rect.left+= 3000;
    rect.right+= 3000;
  }
  MoveWindow(&rect);
}

/////////////////////////////////////////////////////////////////////////////
// // AppWizard generated content

CPluginDlg::CPluginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPluginDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPluginDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CPluginDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPluginDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPluginDlg, CDialog)
	//{{AFX_MSG_MAP(CPluginDlg)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
